﻿function ShowMsg(...)
	return print('|cffFCF75E'..L["addon_name"]..'|r:', ...)
end

-- Slash commands ---------------------------------------------
SLASH_MSS1 = "/mss"
SlashCmdList["MSS"] = function(str)
	local input, input2 = strsplit(" ", str)
	if input == "lock" then 	
		Option_Command_Lock(1)
	elseif input == "unlock" then
		Option_Command_Lock(0)
	elseif input == "show" then
		Option_Command_Display(1)
	elseif input == "hide" then
		Option_Command_Display(0)
	else
		InterfaceOptionsFrame_OpenToCategory(MSS_OptionsPanel)
		ShowMsg("/mss lock 锁定")
		ShowMsg("/mss unlock - 解锁")
		ShowMsg("/mss show - 显示")
		ShowMsg("/mss hide - 隐藏")
		
	end
end


-- Option Persistance    -------------------------------------------------------------
function LoadOptions(self, event, ...) 
	local name = select(1, ...)
	if event == "ADDON_LOADED" and name == "MasterShapeShifter" then	
		
		-- Default values
		if not MSS_SavedOptions then			
			MSS_SavedOptions = {}
			MSS_SavedOptions["lock"] = 0
			MSS_SavedOptions["talent_timer_pos"] = "top"
			MSS_SavedOptions["enable_mss"] = 1
			MSS_SavedOptions["enable_talentbar"] = 1
			MSS_SavedOptions["detach"] = 0
		end
		
		Option_Command_Lock(MSS_SavedOptions["lock"])
		
		Option_Command_Talent_TimerPos(MSS_SavedOptions["talent_timer_pos"])
		
		-- Display	
		Option_Command_EnableMSS(MSS_SavedOptions["enable_mss"])
		
		Option_Command_EnableTalentBar(MSS_SavedOptions["enable_talentbar"])
		
		-- Detach		
		Option_Command_Detach(MSS_SavedOptions["detach"])
		
	--elseif event == "PLAYER_LOGOUT" then		
	end
end


function OptionsPanel_OnLoad(panel)	
	panel.name = "Master Shape Shifter";		
	panel.okay = function(self) end	
	panel.cancel = function (self) end	
	InterfaceOptions_AddCategory(panel);	
end




-- Option commands -------------
function Option_Command_Lock(flag)
	MSS_SavedOptions["lock"] = flag
	if flag == 1 then
		MSS_OptionPanel_CheckButton_Lock:SetChecked(true)
	else
		MSS_OptionPanel_CheckButton_Lock:SetChecked(false)
	end
	
	if flag == 1 then -- lock
		MasterSSMask:RegisterForDrag("")
		MSS_TalentBar:RegisterForDrag("")	
		MasterSS_ComboFrame:RegisterForDrag("")		
	else --unlock
		MasterSSMask:RegisterForDrag("LeftButton")
		MSS_TalentBar:RegisterForDrag("LeftButton")
		if MSS_SavedOptions["detach"] == 1 then
			MasterSS_ComboFrame:RegisterForDrag("LeftButton")		
		end		
	end
end

function Option_Command_Talent_TimerPos(pos)
	MSS_SavedOptions["talent_timer_pos"] = pos
	if pos == "top" then
		MSS_OptionPanel_CheckButton_TalentTimerPos:SetChecked(true)
	else
		MSS_OptionPanel_CheckButton_TalentTimerPos:SetChecked(false)
	end
	
	if pos == "top" then
		MSS_TalentBar_TimeMask3:SetPoint("CENTER", MSS_TalentButton3, "CENTER", 0, 27)
		MSS_TalentBar_TimeMask4:SetPoint("CENTER", MSS_TalentButton4, "CENTER", 0, 27)
		MSS_TalentBar_TimeMask5:SetPoint("CENTER", MSS_TalentButton5, "CENTER", 0, 27)	
	else 
		MSS_TalentBar_TimeMask3:SetPoint("CENTER", MSS_TalentButton3, "CENTER", 0, -27)
		MSS_TalentBar_TimeMask4:SetPoint("CENTER", MSS_TalentButton4, "CENTER", 0, -27)
		MSS_TalentBar_TimeMask5:SetPoint("CENTER", MSS_TalentButton5, "CENTER", 0, -27)	
	end
end

local function ToggleDisplay(id, flag)
	if id == "talentbar" then
		if flag == 0 then
			MSS_TalentBar:Hide()
			MSS_TalentButton1:Hide()
			MSS_TalentButton2:Hide()
			MSS_TalentButton3:Hide()
			MSS_TalentButton4:Hide()
			MSS_TalentButton5:Hide()
			
		else 
			MSS_TalentBar:Show()
			MSS_TalentButton1:Show()
			MSS_TalentButton2:Show()
			MSS_TalentButton3:Show()
			MSS_TalentButton4:Show()
			MSS_TalentButton5:Show()
		end
		
	elseif id == "portrait" then
		if flag == 0 then
			MasterSSMask:Hide()
			MasterSS:Hide()			
		else 
			MasterSSMask:Show()
			MasterSS:Show()			
		end		
	end
end

function Option_Command_EnableMSS(flag)
	MSS_SavedOptions["enable_mss"] = flag
	if flag == 1 then
		MSS_OptionPanel_CheckButton_EnableMSS:SetChecked(true)
	else
		MSS_OptionPanel_CheckButton_EnableMSS:SetChecked(false)
	end	
	ToggleDisplay("portrait", flag)
end

function Option_Command_EnableTalentBar(flag)
	MSS_SavedOptions["enable_talentbar"] = flag
	if flag == 1 then
		MSS_OptionPanel_CheckButton_EnableTalentBar:SetChecked(true)
	else
		MSS_OptionPanel_CheckButton_EnableTalentBar:SetChecked(false)
	end	
	ToggleDisplay("talentbar", flag)
end



function Option_Command_Detach(flag)
	MSS_SavedOptions["detach"] = flag
	if flag == 1 then
		MSS_OptionPanel_CheckButton_DetachComboFrame:SetChecked(true)
	else
		MSS_OptionPanel_CheckButton_DetachComboFrame:SetChecked(false)
	end
	
	if flag == 1 then
		MasterSS_ComboFrame:ClearAllPoints()	
		if MSS_SavedOptions["lock"] == 0 then
				MasterSS_ComboFrame:RegisterForDrag("LeftButton")		
		end
	else 
		MasterSS_ComboFrame:ClearAllPoints()
		MasterSS_ComboFrame:SetPoint("BOTTOMRIGHT", MasterSS, "TOPRIGHT", -20, -15)
		MasterSS_ComboFrame:RegisterForDrag("")		
	end
end